## apr 1.6.5

=== debian/changelog ===
apr (1.6.5-1ubuntu1.1) focal-security; urgency=medium

  * SECURITY UPDATE: local information disclosure via shared memory segments
    - debian/patches/CVE-2023-49582.patch: adjust permissions on shared 
      memory segments to prevent unauthorized access in shmem/unix/shm.c
    - CVE-2023-49582 

 -- Vyom Yadav <vyom.yadav@canonical.com>  Tue, 17 Sep 2024 18:46:02 +0530

apr (1.6.5-1ubuntu1) focal; urgency=medium

  * FTBFS fixes:
    - Build-Depends explicitly on python2, not python.
    - d/p/python2.patch: use python2 in command invocations, not the generic
      python name.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 18 Feb 2020 14:53:35 +0000

apr (1.6.5-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version (no changes).

 -- Stefan Fritsch <sf@debian.org>  Mon, 19 Nov 2018 13:28:03 +0100

apr (1.6.3-3) unstable; urgency=medium

  * Backport fix for undefined behavior in teststr from upstream 1.7.
    Fixes FTBFS with gcc 8. Closes: #897705
  * Migrate from alioth to salsa

 -- Stefan Fritsch <sf@debian.org>  Tue, 17 Jul 2018 21:17:00 +0200

=== debian/control ===
Source: apr
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
Uploaders: Stefan Fritsch <sf@debian.org>
Build-Depends: debhelper (>= 11), autoconf, mawk, uuid-dev, doxygen, netbase, net-tools, libtool (>= 2), python2:any, libsctp-dev [linux-any]
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/apache-team/apr
Vcs-Git: https://salsa.debian.org/apache-team/apr.git
Homepage: http://apr.apache.org/

Package: libapr1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Conflicts: libapr1.0
Description: Apache Portable Runtime Library
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 

Package: libapr1-dev
Architecture: any
Section: libdevel
Depends: libapr1 (= ${binary:Version}), uuid-dev, ${misc:Depends}, libsctp-dev [linux-any]
Suggests: python
Conflicts: libapr1.0-dev, libapr0-dev
Description: Apache Portable Runtime Library - Development Headers
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 This package contains development headers for APR.

Package: libapr1-dbg
Architecture: any
Section: debug
Multi-Arch: same
Depends: libapr1 (= ${binary:Version}), ${misc:Depends}
Description: Apache Portable Runtime Library - Debugging Symbols
 APR is Apache's Portable Runtime Library, designed to be a support library 
 that provides a predictable and consistent interface to underlying 
 platform-specific implementations. 
 .
 This package contains the debugging symbols for APR.

## apr 1.6.5.1

=== debian/changelog ===
apr (1.6.5.1-1+rebuild) unstable; urgency=low

  * ['Autobuild release-candidate: 10aa52eaf95133fb81ac4d95041de0d3155beff0']

 -- shuttle <shuttle@deepin.com>  Wed, 11 Dec 2019 19:59:49 +0000

## apr 1.7.0

=== debian/changelog ===
apr (1.7.0-8build1) jammy; urgency=medium

  * No-change rebuild for ppc64el baseline bump.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Wed, 23 Mar 2022 10:40:37 +0100

apr (1.7.0-8) unstable; urgency=medium

  * Team upload

  [ Salvatore Bonaccorso ]
  * build/apr_common.m4: avoid explicit inclusion of "confdefs.h"
    (Closes: #978767)

 -- Yadd <yadd@debian.org>  Tue, 24 Aug 2021 10:54:34 +0200

apr (1.7.0-7) unstable; urgency=medium

  * Team upload

  [ Helmut Grohne ]
  * Annotate test dependencies netbase and net-tools <!nocheck>.
    Closes: #981738

  [ Salvatore Bonaccorso ]
  * Out-of-bounds array dereference in apr_time_exp*() functions
    (CVE-2021-35940) (Closes: #992789)

 -- Yadd <yadd@debian.org>  Tue, 24 Aug 2021 08:59:10 +0200

apr (1.7.0-6) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Fix atomics for m68k, sh3 and sh4. Closes: #978018

 -- Stefan Fritsch <sf@debian.org>  Sun, 27 Dec 2020 17:28:47 +0100

apr (1.7.0-4) unstable; urgency=low

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Transition to automatic debug package (from: libapr1-dbg).
  * Use secure URI in Homepage field.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.

  [ Stefan Fritsch ]
  * Fix apr libtool on unmerged /usr. Thanks to Vagrant Cascadian for
    the patch. Closes: #916829
  * Bump Standards-Version (no changes).

 -- Stefan Fritsch <sf@debian.org>  Sat, 21 Nov 2020 21:06:09 +0100

apr (1.7.0-3) unstable; urgency=medium

  * Bump Standards-Version (no changes).
  * Fixes for 64bit atomics work-around:
    - call the required initialization
    - don't use on mips64el
    - use on powerpc

 -- Stefan Fritsch <sf@debian.org>  Sun, 30 Aug 2020 21:15:21 +0200

apr (1.7.0-2) unstable; urgency=medium

  * Use generic 64bit atomics on mipsel as gcc lacks the 64bit built-ins.
    Fixes FTBFS on mipsel.

 -- Stefan Fritsch <sf@debian.org>  Sat, 29 Aug 2020 18:13:56 +0200

apr (1.7.0-1) unstable; urgency=medium

  * New upstream release.
    The minimal required linux kernel version is now 3.17.
  * Switch build-depends to python3. Closes: #936128, #969065
    Make apr1-dev depend on python3, so that apr-util does not have to.
    See #936129

 -- Stefan Fritsch <sf@debian.org>  Sat, 29 Aug 2020 11:42:28 +0200

=== debian/control ===
Source: apr
Section: libs
Priority: optional
Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
Uploaders: Stefan Fritsch <sf@debian.org>
Build-Depends: debhelper-compat (= 12),
 autoconf,
 mawk,
 uuid-dev,
 doxygen,
 netbase <!nocheck>,
 net-tools <!nocheck>,
 libtool (>= 2),
 python3:any,
 libsctp-dev [linux-any]
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/apache-team/apr
Vcs-Git: https://salsa.debian.org/apache-team/apr.git
Homepage: https://apr.apache.org/

Package: libapr1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Conflicts: libapr1.0
Description: Apache Portable Runtime Library
 APR is Apache's Portable Runtime Library, designed to be a support library
 that provides a predictable and consistent interface to underlying
 platform-specific implementations.

Package: libapr1-dev
Architecture: any
Section: libdevel
Depends: libapr1 (= ${binary:Version}), uuid-dev, ${misc:Depends}, libsctp-dev [linux-any], python3:any
Conflicts: libapr1.0-dev, libapr0-dev
Description: Apache Portable Runtime Library - Development Headers
 APR is Apache's Portable Runtime Library, designed to be a support library
 that provides a predictable and consistent interface to underlying
 platform-specific implementations.
 .
 This package contains development headers for APR.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
SHELL=/bin/bash
BUILDDIR := debian/build

DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH_BITS  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# The 'build' target needs special handling because there there is a directory
# named 'build'.
.PHONY: build
# The build target must not be empty.  Sadly because of how make
# works, we have do duplicate the target in this case.
build:
	dh $@ -B$(BUILDDIR)
%:
	dh $@ -B$(BUILDDIR)

#
# configure
#
CONFFLAGS := LTFLAGS=--no-silent \
             --host=$(DEB_HOST_GNU_TYPE) \
             --build=$(DEB_BUILD_GNU_TYPE) \
             --enable-layout=Debian \
             --includedir=/usr/include/apr-1.0 \
             --with-installbuilddir=/usr/share/apr-1.0/build \
             --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
             --enable-nonportable-atomics \
             --enable-allocator-uses-mmap \
             ac_cv_prog_AWK=mawk

# apr_cv_mutex_robust_shared causes hangs in procmutex test on arm(el|hf) and alpha
ifneq (,$(findstring armel,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_mutex_robust_shared=no
endif
ifneq (,$(findstring armhf,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_mutex_robust_shared=no
endif
ifneq (,$(findstring alpha,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_mutex_robust_shared=no
endif

# SH4 cannot use proc_pthread.
ifneq (,$(findstring sh4,$(DEB_HOST_ARCH)))
  CONFFLAGS += apr_cv_hasprocpthreadser=no ac_cv_define_PTHREAD_PROCESS_SHARED=no
endif

# multicast not supported on Hurd
ifeq (hurd,$(DEB_HOST_ARCH_OS))
  CONFFLAGS += apr_cv_struct_ipmreq=no
endif

# some minimal cross-building support
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    CONFFLAGS += ac_cv_file__dev_zero=yes \
                 ac_cv_func_setpgrp_void=yes \
                 apr_cv_epoll=yes \
                 ac_cv_struct_rlimit=yes \
                 apr_cv_tcp_nodelay_with_cork=yes \
                 apr_cv_process_shared_works=yes
  endif
  ifeq ($(DEB_HOST_ARCH_BITS),32)
    CONFFLAGS += ac_cv_sizeof_struct_iovec=8
  else ifeq ($(DEB_HOST_ARCH_BITS),64)
    CONFFLAGS += ac_cv_sizeof_struct_iovec=16
  endif
endif

# Set several variables to make build reproducible even when built on
# usrmerge system
CONFFLAGS += SED=/bin/sed
CONFFLAGS += GREP=/bin/grep
CONFFLAGS += EGREP="/bin/grep -E"
CONFFLAGS += FGREP="/bin/grep -F"
CONFFLAGS += ac_cv_path_lt_DD=/bin/dd

override_dh_autoreconf:
	LC_ALL=C dh_autoreconf ./buildconf

override_dh_auto_configure:
	mkdir -p $(BUILDDIR)/docs
	# We need to force the use of bash here. Otherwise, if apr is built with
	# /bin/sh -> /bin/bash, the resulting libtool will not work on systems
	# where /bin/sh -> /bin/dash.
	cd $(BUILDDIR) && CONFIG_SHELL=/bin/bash /bin/bash $(CURDIR)/configure $(CONFFLAGS)
ifeq (linux,$(DEB_HOST_ARCH_OS))
	if grep -q APR_HAS_POSIXSEM_SERIALIZE.*0 $(BUILDDIR)/include/apr.h ;\
	then \
		echo "WARNING: This is Linux but configure did not detect POSIX semaphores." ;\
		if ! df /dev/shm/.|grep -q ^tmpfs ;\
		then \
			echo "ERROR: POSIX semaphores not usable and /dev/shm not mounted." ;\
			echo "ERROR: Aborting." ;\
			echo "HINT: If you are using pbuilder or cowbuilder, add /dev/shm to BINDMOUNTS" ;\
			echo "HINT: in pbuilderrc" ;\
			exit 1 ;\
		fi ;\
	fi
endif


#
# build
#
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

override_dh_auto_build:
	$(MAKE) -j$(NUMJOBS) -C $(BUILDDIR) all dox
	find debian/build/docs/dox/html -name \*.md5 -delete

#
# test
#

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))

# the testsockets test will fail on vservers (no 127.0.0.1) or if ipv6 is
# enabled in the kernel but not configured on any interface
IGNORE_TESTSOCK = $(shell IGN=false; \
	/sbin/ifconfig|grep -q 127.0.0.1 || IGN=true; \
	grep -q ipv6 /proc/net/protocols && ( /sbin/ifconfig|grep -q inet6 || IGN=true ) ; \
	echo $$IGN )

override_dh_auto_test:
	$(MAKE) -C $(BUILDDIR)/test -j$(NUMJOBS) all
	cd $(BUILDDIR)/test && ./testall -v testsockets testsock || $(IGNORE_TESTSOCK)
	cd $(BUILDDIR)/test && ( ulimit -S -s 8192 ; ./testall -v testatomic)
	cd $(BUILDDIR)/test && ./testall -v -x testsockets testsock testatomic

else
override_dh_auto_test:

endif


#
# install
#
override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
	perl -p -i -e "s,^dependency_libs=.*,dependency_libs=''," debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libapr-1.la
	# Remove hostname to make build reproducible
	perl -p -i -e 's/Libtool was configured on host.*//' debian/tmp/usr/share/apr-1.0/build/libtool
	# Replace variable build path with BUILDDIR
	perl -p -i -e "s,$(CURDIR),BUILDDIR/," debian/tmp/usr/bin/apr-1-config
	perl -p -i -e "s,$(CURDIR),BUILDDIR/," debian/tmp/usr/share/apr-1.0/build/apr_rules.mk
	perl -p -i -e "s,$(CURDIR),BUILDDIR/," debian/tmp/usr/share/apr-1.0/build/libtool
	if ! head -n 1 debian/tmp/usr/share/apr-1.0/build/libtool | grep -q /bin/bash ; then \
		echo ERROR: The built libtool uses /bin/sh instead of /bin/bash ; \
		exit 1 ; \
	fi

override_dh_strip:
	dh_strip --dbgsym-migration='libapr1-dbg (<< 1.7.0-4~)'

override_dh_makeshlibs:
	dh_makeshlibs -- -Idebian/symbols.$(DEB_HOST_ARCH_OS)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)

## apr 1.7.2

=== CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Read README.cmake before using this.

# CMAKE_MINIMUM_REQUIRED should be the first directive in the file:
# https://cmake.org/cmake/help/latest/command/cmake_minimum_required.html
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(APR C)

OPTION(APR_INSTALL_PRIVATE_H  "Install selected private .h files (for httpd)"  OFF)
OPTION(APR_HAVE_IPV6        "IPv6 support"                 ON)
OPTION(INSTALL_PDB          "Install .pdb files (if generated)"  ON)
OPTION(APR_BUILD_TESTAPR    "Build the test suite"         OFF)
OPTION(TEST_STATIC_LIBS     "Test programs use APR static libraries instead of shared libraries?" OFF)
SET(MIN_WINDOWS_VER             "Vista" 
    CACHE STRING "Minimum Windows version")

# create 1-or-0 representation of feature tests for apr.h

SET(apr_have_ipv6_10 0)

IF(APR_HAVE_IPV6)
  SET(apr_have_ipv6_10 1)
ENDIF()

IF("${MIN_WINDOWS_VER}" STREQUAL "")
  SET(win32_winnt_str "0x0600")
ELSEIF(${MIN_WINDOWS_VER} STREQUAL "Vista")
  SET(win32_winnt_str "0x0600")
ELSEIF(${MIN_WINDOWS_VER} STREQUAL "Windows7")
  SET(win32_winnt_str "0x0601")
ELSE()
  SET(win32_winnt_str ${MIN_WINDOWS_VER})
ENDIF()

CONFIGURE_FILE(include/apr.hwc
               ${PROJECT_BINARY_DIR}/apr.h)

ADD_EXECUTABLE(gen_test_char tools/gen_test_char.c)

ADD_CUSTOM_COMMAND(
  COMMENT "Generating character tables, apr_escape_test_char.h, for current locale"
  DEPENDS gen_test_char
  COMMAND $<TARGET_FILE:gen_test_char> > ${PROJECT_BINARY_DIR}/apr_escape_test_char.h
  OUTPUT ${PROJECT_BINARY_DIR}/apr_escape_test_char.h
)
ADD_CUSTOM_TARGET(
  test_char_header ALL
  DEPENDS ${PROJECT_BINARY_DIR}/apr_escape_test_char.h
)

# Generated .h files are stored in PROJECT_BINARY_DIR, not the
# source tree.
#
# BROKEN: not searching PROJECT_BINARY_DIR first, so you have to
#         manually delete apr.h in PROJECT_SOURCE_DIR/include if
#         you've generated apr.h before using a different build

SET(APR_INCLUDE_DIRECTORIES
  ${PROJECT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}/include/arch/win32
  ${CMAKE_CURRENT_SOURCE_DIR}/include/arch/unix
  ${CMAKE_CURRENT_SOURCE_DIR}/include/private
)

SET(APR_SYSTEM_LIBS
  ws2_32
  mswsock
  rpcrt4
)

INCLUDE_DIRECTORIES(${APR_INCLUDE_DIRECTORIES})

SET(APR_PUBLIC_HEADERS_STATIC
  include/apr_allocator.h
  include/apr_atomic.h
  include/apr_cstr.h
  include/apr_dso.h
  include/apr_env.h
  include/apr_errno.h
  include/apr_escape.h
  include/apr_file_info.h
  include/apr_file_io.h
  include/apr_fnmatch.h
  include/apr_general.h
  include/apr_getopt.h
  include/apr_global_mutex.h
  include/apr_hash.h
  include/apr_inherit.h
  include/apr_lib.h
  include/apr_mmap.h
  include/apr_network_io.h
  include/apr_perms_set.h
  include/apr_poll.h
  include/apr_pools.h
  include/apr_portable.h
  include/apr_proc_mutex.h
  include/apr_random.h
  include/apr_ring.h
  include/apr_shm.h
  include/apr_signal.h
  include/apr_skiplist.h
  include/apr_strings.h
  include/apr_support.h
  include/apr_tables.h
  include/apr_thread_cond.h
  include/apr_thread_mutex.h
  include/apr_thread_proc.h
  include/apr_thread_rwlock.h
  include/apr_time.h
  include/apr_user.h
  include/apr_version.h
  include/apr_want.h
)
SET(APR_PUBLIC_HEADERS_GENERATED
  ${PROJECT_BINARY_DIR}/apr.h
)

SET(APR_SOURCES
  atomic/win32/apr_atomic.c
  atomic/win32/apr_atomic64.c
  dso/win32/dso.c
  encoding/apr_encode.c
  encoding/apr_escape.c
  file_io/unix/copy.c
  file_io/unix/fileacc.c
  file_io/unix/filepath_util.c
  file_io/unix/fullrw.c
  file_io/unix/mktemp.c
  file_io/unix/tempdir.c
  file_io/win32/buffer.c
  file_io/win32/dir.c
  file_io/win32/filedup.c
  file_io/win32/filepath.c
  file_io/win32/filestat.c
  file_io/win32/filesys.c
  file_io/win32/flock.c
  file_io/win32/open.c
  file_io/win32/pipe.c
  file_io/win32/readwrite.c
  file_io/win32/seek.c
  locks/win32/proc_mutex.c
  locks/win32/thread_cond.c
  locks/win32/thread_mutex.c
  locks/win32/thread_rwlock.c
  memory/unix/apr_pools.c
  misc/unix/errorcodes.c
  misc/unix/getopt.c
  misc/unix/otherchild.c
  misc/unix/version.c
  misc/win32/charset.c
  misc/win32/env.c
  misc/win32/internal.c
  misc/win32/misc.c
  misc/win32/rand.c
  misc/win32/start.c
  misc/win32/utf8.c
  mmap/unix/common.c
  mmap/win32/mmap.c
  network_io/unix/inet_ntop.c
  network_io/unix/inet_pton.c
  network_io/unix/multicast.c
  network_io/unix/sockaddr.c
  network_io/unix/socket_util.c
  network_io/win32/sendrecv.c
  network_io/win32/sockets.c
  network_io/win32/sockopt.c
  passwd/apr_getpass.c
  poll/unix/poll.c
  poll/unix/pollcb.c
  poll/unix/pollset.c
  poll/unix/select.c
  poll/unix/wakeup.c
  random/unix/apr_random.c
  random/unix/sha2.c
  random/unix/sha2_glue.c
  shmem/win32/shm.c
  strings/apr_cpystrn.c
  strings/apr_cstr.c
  strings/apr_fnmatch.c
  strings/apr_snprintf.c
  strings/apr_strings.c
  strings/apr_strnatcmp.c
  strings/apr_strtok.c
  tables/apr_hash.c
  tables/apr_skiplist.c
  tables/apr_tables.c
  threadproc/win32/proc.c
  threadproc/win32/signals.c
  threadproc/win32/thread.c
  threadproc/win32/threadpriv.c
  time/win32/time.c
  time/win32/timestr.c
  user/win32/groupinfo.c
  user/win32/userinfo.c
)

SET(APR_TEST_SUITES
  testargs
  testatomic
  testcond
  testdir
  testdso
  testdup
  testenv
  testencode
  testescape
  testfile
  testfilecopy
  testfileinfo
  testflock
  testfmt
  testfnmatch
  testglobalmutex
  testhash
  testipsub
  testlfs
  testlock
  testmmap
  testnames
  testoc
  testpath
  testpipe
  testpoll
  testpools
  testproc
  testprocmutex
  testrand
  testshm
  testskiplist
  testsleep
  testsock
  testsockets
  testsockopt
  teststr
  teststrnatcmp
  testtable
  testtemp
  testthread
  testtime
  testud
  testuser
  testvsn
)

SET(install_targets)
SET(install_bin_pdb)

# libapr-1 is shared, apr-1 is static
ADD_LIBRARY(libapr-1 SHARED ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED} libapr.rc)
SET(install_targets ${install_targets} libapr-1)
SET(install_bin_pdb ${install_bin_pdb} ${PROJECT_BINARY_DIR}/libapr-1.pdb)
TARGET_LINK_LIBRARIES(libapr-1 ${APR_SYSTEM_LIBS})
SET_TARGET_PROPERTIES(libapr-1 PROPERTIES COMPILE_DEFINITIONS "APR_DECLARE_EXPORT;WINNT")
ADD_DEPENDENCIES(libapr-1 test_char_header)

ADD_LIBRARY(apr-1 STATIC ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED})
SET(install_targets ${install_targets} apr-1)
TARGET_LINK_LIBRARIES(apr-1 ${APR_SYSTEM_LIBS})
SET_TARGET_PROPERTIES(apr-1 PROPERTIES COMPILE_DEFINITIONS "APR_DECLARE_STATIC;WINNT")
ADD_DEPENDENCIES(apr-1 test_char_header)

# libaprapp-1 and aprapp-1 are static
ADD_LIBRARY(libaprapp-1 STATIC misc/win32/apr_app.c misc/win32/internal.c ${APR_PUBLIC_HEADERS_GENERATED})
SET(install_targets ${install_targets} libaprapp-1)
SET_TARGET_PROPERTIES(libaprapp-1 PROPERTIES COMPILE_DEFINITIONS "APR_APP;WINNT")

ADD_LIBRARY(aprapp-1 STATIC misc/win32/apr_app.c misc/win32/internal.c ${APR_PUBLIC_HEADERS_GENERATED})
SET(install_targets ${install_targets} aprapp-1)
SET_TARGET_PROPERTIES(aprapp-1 PROPERTIES COMPILE_DEFINITIONS "APR_DECLARE_STATIC;APR_APP;WINNT")

IF(APR_BUILD_TESTAPR)
  ENABLE_TESTING()
  # Create a "check" target that displays test program output to the console.
  ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND} --verbose)

  # copy data files to build directory so that we can run programs from there
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E make_directory 
                  ${PROJECT_BINARY_DIR}/data)
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E copy_if_different 
                  ${PROJECT_SOURCE_DIR}/test/data/file_datafile.txt
                  ${PROJECT_BINARY_DIR}/data/file_datafile.txt)
  EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E copy_if_different
                  ${PROJECT_SOURCE_DIR}/test/data/mmap_datafile.txt
                  ${PROJECT_BINARY_DIR}/data/mmap_datafile.txt)

  IF(TEST_STATIC_LIBS)
    SET(whichapr    apr-1)
    SET(whichaprapp aprapp-1)
    SET(apiflag     -DAPR_DECLARE_STATIC)
  ELSE()
    SET(whichapr    libapr-1)
    SET(whichaprapp libaprapp-1)
    SET(apiflag)
  ENDIF()

  ADD_EXECUTABLE(testapp test/testapp.c)
  TARGET_LINK_LIBRARIES(testapp ${whichapr} ${whichaprapp} ${APR_SYSTEM_LIBS})
  SET_TARGET_PROPERTIES(testapp PROPERTIES LINK_FLAGS /entry:wmainCRTStartup)
  IF(apiflag)
    SET_TARGET_PROPERTIES(testapp PROPERTIES COMPILE_FLAGS ${apiflag})
  ENDIF()
  ADD_TEST(NAME testapp COMMAND testapp)

  SET (APR_TEST_SOURCES
    test/abts.c
    test/testutil.c
    )

  FOREACH(testsuite ${APR_TEST_SUITES})
    LIST(APPEND APR_TEST_SOURCES test/${testsuite}.c)
  ENDFOREACH()

  ADD_EXECUTABLE(testall ${APR_TEST_SOURCES})
  TARGET_LINK_LIBRARIES(testall ${whichapr} ${APR_SYSTEM_LIBS})
  SET_TARGET_PROPERTIES(testall PROPERTIES COMPILE_DEFINITIONS "BINPATH=$<TARGET_FILE_DIR:testall>")
  IF(apiflag)
    SET_TARGET_PROPERTIES(testall PROPERTIES COMPILE_FLAGS ${apiflag})
  ENDIF()

  FOREACH(test ${APR_TEST_SUITES})
    ADD_TEST(NAME ${test} COMMAND testall -v ${test})
  ENDFOREACH()

  ADD_LIBRARY(mod_test MODULE test/mod_test.c)
  TARGET_LINK_LIBRARIES(mod_test ${whichapr} ${APR_SYSTEM_LIBS})
  SET_PROPERTY(TARGET mod_test APPEND PROPERTY LINK_FLAGS /export:print_hello)
  # nasty work-around for difficulties adding more than one additional flag
  # (they get joined in a bad way behind the scenes)
  GET_PROPERTY(link_flags TARGET mod_test PROPERTY LINK_FLAGS)
  SET(link_flags "${link_flags} /export:count_reps")
  SET_TARGET_PROPERTIES(mod_test PROPERTIES LINK_FLAGS ${link_flags})
  IF(apiflag)
    SET_TARGET_PROPERTIES(mod_test PROPERTIES COMPILE_FLAGS ${apiflag})
  ENDIF()

  # Build all the single-source executable files with no special build
  # requirements.
  SET(single_source_programs
    test/echod.c
    test/sendfile.c
    test/sockperf.c
    test/testlockperf.c
    test/testmutexscope.c
    test/globalmutexchild.c
    test/occhild.c
    test/proc_child.c
    test/readchild.c
    test/sockchild.c
    test/testshmproducer.c
    test/testshmconsumer.c
    test/tryread.c
    test/internal/testucs.c
  )

  FOREACH(sourcefile ${single_source_programs})
    STRING(REGEX REPLACE ".*/([^\\]+)\\.c" "\\1" proggie ${sourcefile})
    ADD_EXECUTABLE(${proggie} ${sourcefile})
    TARGET_LINK_LIBRARIES(${proggie} ${whichapr} ${APR_SYSTEM_LIBS})
    SET_TARGET_PROPERTIES(${proggie} PROPERTIES COMPILE_DEFINITIONS "BINPATH=$<TARGET_FILE_DIR:${proggie}>")
    IF(apiflag)
      SET_TARGET_PROPERTIES(${proggie} PROPERTIES COMPILE_FLAGS ${apiflag})
    ENDIF()
  ENDFOREACH()

  # Add tests for programs that run by themselves with no arguments.
  SET(simple_tests
    testmutexscope
    testucs
  )

  FOREACH(simple ${simple_tests})
    ADD_TEST(NAME ${simple} COMMAND ${simple})
  ENDFOREACH()

  # testlockperf takes forever on Windows with default counter limit
  ADD_TEST(NAME testlockperf COMMAND testlockperf -c 50000)

  # sendfile runs multiple times with different parameters.
  FOREACH(sendfile_mode blocking nonblocking timeout)
    ADD_TEST(NAME sendfile-${sendfile_mode} COMMAND sendfile client ${sendfile_mode} startserver)
  ENDFOREACH()

  # No test is added for echod+sockperf.  Those will have to be run manually.

ENDIF (APR_BUILD_TESTAPR)

# Installation

INSTALL(TARGETS ${install_targets}
        RUNTIME DESTINATION bin

=== debian/changelog ===
apr (1.7.2-3.1~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Steve Langasek <vorlon@debian.org>  Tue, 30 Jan 2024 00:57:26 +0000

apr (1.7.2-3) unstable; urgency=medium

  * Add more fixes for atomics from upstream, in particular for
    32 bit archs with weak memory ordering.

 -- Stefan Fritsch <sf@debian.org>  Sun, 26 Feb 2023 21:51:24 +0100

apr (1.7.2-2) unstable; urgency=medium

  * Fix 64bit atomics on powerpc and armel.
  * Bump standards version (no changes).

 -- Stefan Fritsch <sf@debian.org>  Sat, 04 Feb 2023 12:08:53 +0100

apr (1.7.2-1) unstable; urgency=medium

  [ Stefan Fritsch ]
  * New upstream version
    - CVE-2022-24963: Integer Overflow or Wraparound vulnerability
      in apr_encode functions
  * Include PrintPath in libapr1-dev.

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Re-export upstream signing key without extra signatures.
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on libtool.

  [ Yadd ]
  * Bump standards version
  * Modernize debian/watch
  * Add "Rules-Requires-Root: no"

 -- Stefan Fritsch <sf@debian.org>  Thu, 02 Feb 2023 23:55:35 +0100

=== debian/control ===
--- 
+++ 
@@ -3,22 +3,26 @@
 Priority: optional
 Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
 Uploaders: Stefan Fritsch <sf@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  autoconf,
  mawk,
  uuid-dev,
  doxygen,
  netbase <!nocheck>,
  net-tools <!nocheck>,
- libtool (>= 2),
+ libtool,
  python3:any,
  libsctp-dev [linux-any]
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/apache-team/apr
 Vcs-Git: https://salsa.debian.org/apache-team/apr.git
 Homepage: https://apr.apache.org/
+Rules-Requires-Root: no
 
-Package: libapr1
+Package: libapr1t64
+Provides: ${t64:Provides}
+Replaces: libapr1
+Breaks: libapr1 (<< ${source:Version})
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}

## apr 1.7.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,13 +21,44 @@
 
 PROJECT(APR C)
 
+# Enable support for MSVC runtime library selection by abstraction
+# if supported by CMake.
+IF(POLICY CMP0091)
+  CMAKE_POLICY(SET CMP0091 NEW)
+ENDIF()
+
+# Add simple support CMAKE_WARNING_AS_ERROR if CMake doesn't
+# support it.
+IF (CMAKE_VERSION VERSION_LESS 3.24)
+  IF(CMAKE_WARNING_AS_ERROR AND MSVC)
+    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /WX")
+  ENDIF()
+ENDIF()
+
+SET(apr_name    apr-1)
+SET(apr_libname libapr-1)
+
 OPTION(APR_INSTALL_PRIVATE_H  "Install selected private .h files (for httpd)"  OFF)
 OPTION(APR_HAVE_IPV6        "IPv6 support"                 ON)
 OPTION(INSTALL_PDB          "Install .pdb files (if generated)"  ON)
 OPTION(APR_BUILD_TESTAPR    "Build the test suite"         OFF)
+OPTION(APR_BUILD_SHARED     "Build shared libraries"       ON)
+OPTION(APR_BUILD_STATIC     "Build static libraries"       ON)
 OPTION(TEST_STATIC_LIBS     "Test programs use APR static libraries instead of shared libraries?" OFF)
 SET(MIN_WINDOWS_VER             "Vista" 
     CACHE STRING "Minimum Windows version")
+
+SET(APR_INSTALL_BIN_DIR      "bin"                       CACHE STRING "Install subdirectory for binary files")
+SET(APR_INSTALL_LIB_DIR      "lib"                       CACHE STRING "Install subdirectory for library files")
+SET(APR_INSTALL_INCLUDE_DIR  "include"                   CACHE STRING "Install subdirectory for include files")
+
+IF(NOT APR_BUILD_SHARED AND NOT APR_BUILD_STATIC)
+  MESSAGE(FATAL_ERROR "Both APR_BUILD_SHARED and APR_BUILD_STATIC have been disabled")
+ENDIF()
+
+IF(NOT APR_BUILD_STATIC AND TEST_STATIC_LIBS)
+  MESSAGE(FATAL_ERROR "APR_BUILD_STATIC has been disabled, but TEST_STATIC_LIBS is enabled")
+ENDIF()
 
 # create 1-or-0 representation of feature tests for apr.h
 
@@ -47,6 +78,13 @@
   SET(win32_winnt_str ${MIN_WINDOWS_VER})
 ENDIF()
 
+# Read current version.
+FILE(STRINGS include/apr_version.h VERSION_STRINGS REGEX "#define (APR_MAJOR_VERSION|APR_MINOR_VERSION|APR_PATCH_VERSION)")
+
+STRING(REGEX REPLACE ".*#define APR_MAJOR_VERSION[ \t]+([0-9]+).*" "\\1" APR_MAJOR_VERSION ${VERSION_STRINGS})
+STRING(REGEX REPLACE ".*#define APR_MINOR_VERSION[ \t]+([0-9]+).*" "\\1" APR_MINOR_VERSION ${VERSION_STRINGS})
+STRING(REGEX REPLACE ".*#define APR_PATCH_VERSION[ \t]+([0-9]+).*" "\\1" APR_PATCH_VERSION ${VERSION_STRINGS})
+
 CONFIGURE_FILE(include/apr.hwc
                ${PROJECT_BINARY_DIR}/apr.h)
 
@@ -71,16 +109,15 @@
 #         you've generated apr.h before using a different build
 
 SET(APR_INCLUDE_DIRECTORIES
-  ${PROJECT_BINARY_DIR}
-  ${CMAKE_CURRENT_SOURCE_DIR}/include
-  ${CMAKE_CURRENT_SOURCE_DIR}/include/arch/win32
-  ${CMAKE_CURRENT_SOURCE_DIR}/include/arch/unix
-  ${CMAKE_CURRENT_SOURCE_DIR}/include/private
+  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/arch/win32>
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/arch/unix>
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/private>
 )
 
 SET(APR_SYSTEM_LIBS
   ws2_32
-  mswsock
   rpcrt4
 )
 
@@ -261,28 +298,62 @@
 SET(install_targets)
 SET(install_bin_pdb)
 
+IF (MSVC)
+  # Ignore Microsoft's interpretation of secure development
+  # and the POSIX string handling API
+  ADD_COMPILE_DEFINITIONS(_CRT_SECURE_NO_DEPRECATE _CRT_NONSTDC_NO_WARNINGS)
+ENDIF()
+
 # libapr-1 is shared, apr-1 is static
-ADD_LIBRARY(libapr-1 SHARED ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED} libapr.rc)
-SET(install_targets ${install_targets} libapr-1)
-SET(install_bin_pdb ${install_bin_pdb} ${PROJECT_BINARY_DIR}/libapr-1.pdb)
-TARGET_LINK_LIBRARIES(libapr-1 ${APR_SYSTEM_LIBS})
-SET_TARGET_PROPERTIES(libapr-1 PROPERTIES COMPILE_DEFINITIONS "APR_DECLARE_EXPORT;WINNT")
-ADD_DEPENDENCIES(libapr-1 test_char_header)
-
-ADD_LIBRARY(apr-1 STATIC ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED})
-SET(install_targets ${install_targets} apr-1)
-TARGET_LINK_LIBRARIES(apr-1 ${APR_SYSTEM_LIBS})
-SET_TARGET_PROPERTIES(apr-1 PROPERTIES COMPILE_DEFINITIONS "APR_DECLARE_STATIC;WINNT")
-ADD_DEPENDENCIES(apr-1 test_char_header)
+IF (APR_BUILD_SHARED)
+  ADD_LIBRARY(${apr_libname} SHARED ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED} libapr.rc)
+  LIST(APPEND install_targets ${apr_libname})
+  LIST(APPEND install_bin_pdb ${PROJECT_BINARY_DIR}/${apr_libname}.pdb)
+  TARGET_LINK_LIBRARIES(${apr_libname}
+                        PRIVATE ${APR_SYSTEM_LIBS})
+  TARGET_COMPILE_DEFINITIONS(${apr_libname}
+                             PRIVATE "APR_DECLARE_EXPORT;WINNT"
+                             INTERFACE "APR_DECLARE_IMPORT;WINNT")
+  TARGET_INCLUDE_DIRECTORIES(${apr_libname}
+    PRIVATE ${APR_INCLUDE_DIRECTORIES}
+    INTERFACE $<INSTALL_INTERFACE:${APR_INSTALL_INCLUDE_DIR}> ${APR_INCLUDE_DIRECTORIES}
+  )
+  ADD_DEPENDENCIES(${apr_libname} test_char_header)
+ENDIF()
+
+IF (APR_BUILD_STATIC)
+  ADD_LIBRARY(${apr_name} STATIC ${APR_SOURCES} ${APR_PUBLIC_HEADERS_GENERATED})
+  LIST(APPEND install_targets ${apr_name})
+  TARGET_LINK_LIBRARIES(${apr_name}
+                        PRIVATE ${APR_SYSTEM_LIBS})
+  TARGET_COMPILE_DEFINITIONS(${apr_name}
+                             PRIVATE "APR_DECLARE_STATIC;WINNT"
+                             INTERFACE "APR_DECLARE_STATIC;WINNT")
+  TARGET_INCLUDE_DIRECTORIES(${apr_name}
+    PRIVATE ${APR_INCLUDE_DIRECTORIES}
+    INTERFACE $<INSTALL_INTERFACE:${APR_INSTALL_INCLUDE_DIR}> ${APR_INCLUDE_DIRECTORIES}
+  )
+  ADD_DEPENDENCIES(${apr_name} test_char_header)
+ENDIF()
 
 # libaprapp-1 and aprapp-1 are static
-ADD_LIBRARY(libaprapp-1 STATIC misc/win32/apr_app.c misc/win32/internal.c ${APR_PUBLIC_HEADERS_GENERATED})
-SET(install_targets ${install_targets} libaprapp-1)
-SET_TARGET_PROPERTIES(libaprapp-1 PROPERTIES COMPILE_DEFINITIONS "APR_APP;WINNT")
-
-ADD_LIBRARY(aprapp-1 STATIC misc/win32/apr_app.c misc/win32/internal.c ${APR_PUBLIC_HEADERS_GENERATED})
-SET(install_targets ${install_targets} aprapp-1)
-SET_TARGET_PROPERTIES(aprapp-1 PROPERTIES COMPILE_DEFINITIONS "APR_DECLARE_STATIC;APR_APP;WINNT")
+IF (APR_BUILD_SHARED)
+  ADD_LIBRARY(libaprapp-1 STATIC misc/win32/apr_app.c misc/win32/internal.c ${APR_PUBLIC_HEADERS_GENERATED})
+  LIST(APPEND install_targets libaprapp-1)
+  SET_TARGET_PROPERTIES(libaprapp-1 PROPERTIES COMPILE_DEFINITIONS "APR_APP;WINNT")
+  TARGET_INCLUDE_DIRECTORIES(libaprapp-1
+    PRIVATE ${APR_INCLUDE_DIRECTORIES}
+  )
+ENDIF()
+
+IF (APR_BUILD_STATIC)
+  ADD_LIBRARY(aprapp-1 STATIC misc/win32/apr_app.c misc/win32/internal.c ${APR_PUBLIC_HEADERS_GENERATED})
+  LIST(APPEND install_targets aprapp-1)
+  SET_TARGET_PROPERTIES(aprapp-1 PROPERTIES COMPILE_DEFINITIONS "APR_DECLARE_STATIC;APR_APP;WINNT")
+  TARGET_INCLUDE_DIRECTORIES(aprapp-1
+    PRIVATE ${APR_INCLUDE_DIRECTORIES}
+  )
+ENDIF()
 
 IF(APR_BUILD_TESTAPR)
   ENABLE_TESTING()
@@ -300,21 +371,16 @@
                   ${PROJECT_BINARY_DIR}/data/mmap_datafile.txt)
 
   IF(TEST_STATIC_LIBS)
-    SET(whichapr    apr-1)
+    SET(whichapr    ${apr_name})
     SET(whichaprapp aprapp-1)
-    SET(apiflag     -DAPR_DECLARE_STATIC)
   ELSE()
-    SET(whichapr    libapr-1)
+    SET(whichapr    ${apr_libname})
     SET(whichaprapp libaprapp-1)
-    SET(apiflag)
   ENDIF()
 
   ADD_EXECUTABLE(testapp test/testapp.c)
-  TARGET_LINK_LIBRARIES(testapp ${whichapr} ${whichaprapp} ${APR_SYSTEM_LIBS})
+  TARGET_LINK_LIBRARIES(testapp ${whichapr} ${whichaprapp})
   SET_TARGET_PROPERTIES(testapp PROPERTIES LINK_FLAGS /entry:wmainCRTStartup)
-  IF(apiflag)
-    SET_TARGET_PROPERTIES(testapp PROPERTIES COMPILE_FLAGS ${apiflag})
-  ENDIF()
   ADD_TEST(NAME testapp COMMAND testapp)
 
   SET (APR_TEST_SOURCES
@@ -326,81 +392,3 @@
     LIST(APPEND APR_TEST_SOURCES test/${testsuite}.c)
   ENDFOREACH()
 
-  ADD_EXECUTABLE(testall ${APR_TEST_SOURCES})
-  TARGET_LINK_LIBRARIES(testall ${whichapr} ${APR_SYSTEM_LIBS})
-  SET_TARGET_PROPERTIES(testall PROPERTIES COMPILE_DEFINITIONS "BINPATH=$<TARGET_FILE_DIR:testall>")
-  IF(apiflag)
-    SET_TARGET_PROPERTIES(testall PROPERTIES COMPILE_FLAGS ${apiflag})
-  ENDIF()
-
-  FOREACH(test ${APR_TEST_SUITES})
-    ADD_TEST(NAME ${test} COMMAND testall -v ${test})
-  ENDFOREACH()
-
-  ADD_LIBRARY(mod_test MODULE test/mod_test.c)
-  TARGET_LINK_LIBRARIES(mod_test ${whichapr} ${APR_SYSTEM_LIBS})
-  SET_PROPERTY(TARGET mod_test APPEND PROPERTY LINK_FLAGS /export:print_hello)
-  # nasty work-around for difficulties adding more than one additional flag
-  # (they get joined in a bad way behind the scenes)
-  GET_PROPERTY(link_flags TARGET mod_test PROPERTY LINK_FLAGS)
-  SET(link_flags "${link_flags} /export:count_reps")
-  SET_TARGET_PROPERTIES(mod_test PROPERTIES LINK_FLAGS ${link_flags})
-  IF(apiflag)
-    SET_TARGET_PROPERTIES(mod_test PROPERTIES COMPILE_FLAGS ${apiflag})
-  ENDIF()
-
-  # Build all the single-source executable files with no special build
-  # requirements.
-  SET(single_source_programs
-    test/echod.c
-    test/sendfile.c
-    test/sockperf.c
-    test/testlockperf.c
-    test/testmutexscope.c
-    test/globalmutexchild.c
-    test/occhild.c
-    test/proc_child.c
-    test/readchild.c
-    test/sockchild.c
-    test/testshmproducer.c
-    test/testshmconsumer.c
-    test/tryread.c
-    test/internal/testucs.c
-  )
-
-  FOREACH(sourcefile ${single_source_programs})
-    STRING(REGEX REPLACE ".*/([^\\]+)\\.c" "\\1" proggie ${sourcefile})
-    ADD_EXECUTABLE(${proggie} ${sourcefile})
-    TARGET_LINK_LIBRARIES(${proggie} ${whichapr} ${APR_SYSTEM_LIBS})
-    SET_TARGET_PROPERTIES(${proggie} PROPERTIES COMPILE_DEFINITIONS "BINPATH=$<TARGET_FILE_DIR:${proggie}>")
-    IF(apiflag)
-      SET_TARGET_PROPERTIES(${proggie} PROPERTIES COMPILE_FLAGS ${apiflag})
-    ENDIF()
-  ENDFOREACH()
-
-  # Add tests for programs that run by themselves with no arguments.
-  SET(simple_tests
-    testmutexscope
-    testucs
-  )
-
-  FOREACH(simple ${simple_tests})
-    ADD_TEST(NAME ${simple} COMMAND ${simple})
-  ENDFOREACH()
-
-  # testlockperf takes forever on Windows with default counter limit
-  ADD_TEST(NAME testlockperf COMMAND testlockperf -c 50000)
-
-  # sendfile runs multiple times with different parameters.
-  FOREACH(sendfile_mode blocking nonblocking timeout)
-    ADD_TEST(NAME sendfile-${sendfile_mode} COMMAND sendfile client ${sendfile_mode} startserver)
-  ENDFOREACH()
-
-  # No test is added for echod+sockperf.  Those will have to be run manually.
-
-ENDIF (APR_BUILD_TESTAPR)
-
-# Installation
-
-INSTALL(TARGETS ${install_targets}
-        RUNTIME DESTINATION bin

=== debian/changelog ===
apr (1.7.5-1) unstable; urgency=medium

  * New usptream version
    - CVE-2023-49582: Unexpected lax shared memory permissions
      Closes: #1080375

 -- Stefan Fritsch <sf@debian.org>  Sat, 07 Sep 2024 11:01:36 +0200

apr (1.7.2-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix symbols files which are in a non-standard location.

 -- Steve Langasek <vorlon@debian.org>  Fri, 08 Mar 2024 19:11:28 +0000

apr (1.7.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061894

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 01:17:18 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Apache Maintainers <debian-apache@lists.debian.org>
 Uploaders: Stefan Fritsch <sf@debian.org>
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
  autoconf,
  mawk,
  uuid-dev,
@@ -36,7 +36,7 @@
 Package: libapr1-dev
 Architecture: any
 Section: libdevel
-Depends: libapr1 (= ${binary:Version}), uuid-dev, ${misc:Depends}, libsctp-dev [linux-any], python3:any
+Depends: libapr1t64 (= ${binary:Version}), uuid-dev, ${misc:Depends}, libsctp-dev [linux-any], python3:any
 Conflicts: libapr1.0-dev, libapr0-dev
 Description: Apache Portable Runtime Library - Development Headers
  APR is Apache's Portable Runtime Library, designed to be a support library

## apr 1.7.6

=== debian/changelog ===
apr (1.7.6-1) unstable; urgency=medium

  [ Helmut Grohne ]
  * Explicitly depend on libcrypt-dev. (Closes: #1102909)
  * Fix FTCBFS: Supply result for cross-process mutex. (Closes: #1050770)

  [ Stefan Fritsch ]
  * New upstream version
  * Enable sctp explicitly in configure. Closes: #1104500

 -- Stefan Fritsch <sf@debian.org>  Wed, 05 Nov 2025 21:59:04 +0100

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Uploaders: Stefan Fritsch <sf@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
  autoconf,
+ libcrypt-dev,
  mawk,
  uuid-dev,
  doxygen,
@@ -36,7 +37,7 @@
 Package: libapr1-dev
 Architecture: any
 Section: libdevel
-Depends: libapr1t64 (= ${binary:Version}), uuid-dev, ${misc:Depends}, libsctp-dev [linux-any], python3:any
+Depends: libapr1t64 (= ${binary:Version}), libcrypt-dev, uuid-dev, ${misc:Depends}, libsctp-dev [linux-any], python3:any
 Conflicts: libapr1.0-dev, libapr0-dev
 Description: Apache Portable Runtime Library - Development Headers
  APR is Apache's Portable Runtime Library, designed to be a support library

=== debian/rules ===
--- 
+++ 
@@ -33,17 +33,17 @@
              --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
              --enable-nonportable-atomics \
              --enable-allocator-uses-mmap \
+             --enable-sctp \
              ac_cv_prog_AWK=mawk
 
 # apr_cv_mutex_robust_shared causes hangs in procmutex test on arm(el|hf) and alpha
-ifneq (,$(findstring armel,$(DEB_HOST_ARCH)))
+ifneq (,$(filter $(DEB_HOST_ARCH),alpha armel armhf))
   CONFFLAGS += apr_cv_mutex_robust_shared=no
+else
+# apr_cv_mutex_robust_shared cannot be detected during cross compilation
+ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
+  CONFFLAGS += apr_cv_mutex_robust_shared=yes
 endif
-ifneq (,$(findstring armhf,$(DEB_HOST_ARCH)))
-  CONFFLAGS += apr_cv_mutex_robust_shared=no
-endif
-ifneq (,$(findstring alpha,$(DEB_HOST_ARCH)))
-  CONFFLAGS += apr_cv_mutex_robust_shared=no
 endif
 
 # SH4 cannot use proc_pthread.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
http://www.apache.org/dist/apr/apr-(1\..*)\.tar\.gz
